Subject: bug#37482: Guix fails to build libreoffice

From: Jesse Gibbons <[email-masked]>
Date: Sun, 22 Sep 2019 12:28:45 -0600

On Sun, 2019-09-22 at 19:45 +0200, Tobias Geerinckx-Rice via Bug reports for
GNU Guix wrote:
> Jan,
> 
> Thanks for the report, and sorry you had to learn this the hard 
> way.
> 
> Jan Wielkiewicz 写道：
> > I've recently tried to reconfigure my system, but after about 3 
> > hours
> > of building libreoffice, the system froze for 2 hours and then 
> > guix
> > threw:
> 
> […]
> 
> > g++: internal compiler error: Killed (program cc1plus)
> > Please submit a full bug report,
> > with preprocessed source if appropriate.
> > See <http://gcc.gnu.org/bugs.html> for instructions.
> 
> This message and the freezing above is a tell-tale sign of OOM 
> (out-of-memory).  If you check your dmesg or /var/log/messages at 
> that time, I'm almost certain you'll see the OOM killer plot its 
> dastardly deeds.
> 
> > My system is an old ThinkPad with 2GB of RAM and Intel Centrino 
> > Duo
> > processor, but I'm unsure if this was the cause of the build 
> > failing.
> 
> You may be sure.
> 
> 2 GiB of RAM is simply not enough to build many packages these 
> days.  That's the world we live in.  There's nothing Guix can do 
> to change that.
> 
> You can restrict the number of parallel builds and jobs by 
> respectively passing --max-jobs=1 and --cores=1 to the daemon. 
> You can make this permanent by setting (extra-options …) in your 
> system configuration.
> 
> Even then, some complex executables will simply fail to link with 
> so little RAM.

You can get around too little RAM by using swap, correct? Partition ~8GB as
swap and add (swap-devices) in the configuration.